<template>
  <div class="modal_4">
    <div class="modal" v-bind:class="{ active: isActive }" id="modal-id">
      <span class="modal-overlay"></span>
      <a href="#close" class="modal-overlay" aria-label="Close"></a>
      <div class="modal-container inactive" id="modalContainer">
        <div class="modal-header inactive">
         <div class="heading1" >
            <a v-on:click="close" class="btn btn-clear float-right close-btn" aria-label="Close"></a>
            <div class="modal-title h5"><span class="package_tag_header">{{this.clickedpackage.tag}}</span> Package Template</div>
          </div>
        </div>
        <div class="modal-body inactive">
          <div class="modal_content" id="content">
            <div class="container">
              <div class="columns">
                <div class="column package-section top-actions">
                  <div class="float-right">
                    <button class="btn btn-package" @click="addRow">Add Earnings</button>
                  </div>
                </div>
              </div>
              <div class="columns">
                <div class="column package-section">
                  <h5>Package Earnings</h5>
                  <table class="table">
                    <thead>
                      <tr>
                        <th>Type</th>
                        <th>Frequency</th>
                        <th>Basis</th>
                        <th>Rate</th>
                        <th></th>
                      </tr>
                    </thead>
                    <tbody ref="editable_table">
                      <tr v-for="(e, index) in earnings" v-bind:key="index">
                        <td>
                          <span v-if="e.is_editable">
                            <select class="form-select" v-model="earning.type">
                              <option value="">Choose type</option>
                              <option v-for="type in types" v-bind:key="type">{{ type }}</option>
                            </select>
                          </span>
                          <span v-else>{{ e.type }}</span>
                        </td>
                        <td>
                          <span v-if="e.is_editable">
                            <select class="form-select" v-model="earning.frequency">
                              <option v-for="frequency in frequencies" v-bind:key="frequency">{{frequency}}</option>
                            </select>
                          </span>
                          <span v-else>{{ e.frequency }}</span>
                        </td>
                        <td>
                          <span v-if="e.is_editable">
                            <select class="form-select" v-model="earning.basis">
                              <option value="">Choose basis</option>
                              <option v-for="base in basis" v-bind:key="base">{{ base }}</option>
                            </select>
                          </span>
                          <span v-else>{{ e.basis }}</span>
                        </td>
                        <td>
                          <span v-if="e.is_editable">
                            <input class="form-input" type="number" v-model="earning.rate"/>
                          </span>
                          <span v-else>{{ e.rate }}</span>
                        </td>
                        <td>
                          <span v-if="e.is_editable">
                            <span @click="addItem(index)"><img src="/images/icons/content-save.svg" alt="Save icon" class="table_icon"/></span> |
                            <span @click="cancelItem(index)"><img src="/images/icons/close-circle.svg" alt="Cancel icon" class="table_icon"/></span>
                          </span>
                          <div v-else>
                            <span @click="editRow(index)"><img src="/images/icons/pencil-outline.svg" alt="Edit icon" class="table_icon"/></span> |
                            <span @click="deleteRow(index)"><img src="/images/icons/delete-outline.svg" alt="Delete icon" class="table_icon"/></span>
                          </div>
                        </td>
                      </tr>
                    </tbody>
                  </table>
                </div>
              </div>
              <div class="columns">
                <div class="column package-section">
                  <div class="float-right btm-actions">
                    <button class="btn btn-package" @click="exportData">Submit Package</button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import axios from 'axios'
export default {
  name: "modal_4",
  props: ["clickedpackage"],
  components: {
    
  },
  data() {
    return {
    show_modal: false,
    basis: ["Daily", "Hourly", "Monthly"],  
    isActive: true,
    id: parseInt(this.clickedpackage.id),
    earnings: '',
    frequencies: ["Daily", "Weekly", "Monthly", "Fortnightly"],
    packages: [],
    types: ["Salary", "Housing", "Transport"],
    earning: {
        "type": "Salary",
        "frequency": "Daily",
        "basis": "Monthly",
        "rate": 0
      },
    } },

  methods:{
    close(event) {
       this.$emit("close", this.display_show_modal); 
     
    },
    addItem(index) {
      this.earnings[index].type = this.earning.type
      this.earnings[index].frequency = this.earning.frequency
      this.earnings[index].basis = this.earning.basis
      this.earnings[index].rate = this.earning.rate
      this.earnings[index].is_editable = false
      
      this.resetEarning()
    },
    addRow() {
      this.earnings.push({
        "type": "Salary",
        "frequency": "Daily",
        "basis": "Monthly",
        "rate": 0,
        "is_editable": true
      })
    },
    editRow(index) {
      this.$set(this.earnings[index], 'is_editable', true)
      this.earning.type = this.earnings[index].type,
      this.earning.frequency = this.earnings[index].frequency,
      this.earning.basis = this.earnings[index].basis,
      this.earning.rate = this.earnings[index].rate
    },
    resetEarning() {
      this.earning.type = "Salary",
      this.earning.frequency = "Daily",
      this.earning.basis = "Monthly",
      this.earning.rate = 0
    },
    exportData() {
    console.log(this.id)
    const axios = require("axios");
    var url = "/api/earnings/upsert";
    var params = {package:this.id, earning:this.earnings};
    let csrf = document.querySelector("meta[name='csrf-token']").getAttribute("content");
    axios.post(url, params,  { headers: {'Content-Type': 'application/json', 'x-csrf-token': csrf}})
    .then(response => {
      
      
    });
    }

  }, 
    cancelItem(index) { }, 

  mounted(){
    const axios = require("axios");
    var url = "/api/earnings/"+ this.id;
    axios.get(url)
    .then(response => {
      this.earnings = response.data.earning
      
    });
  
  }  
 
    
    }
</script>
<style>
</style>